Index: drivers/serial/tsuart-73.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-73.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/serial/tsuart-73.c	16 May 2006 19:11:01 -0000	1.1
+++ drivers/serial/tsuart-73.c	11 Jan 2007 00:44:41 -0000	1.5
@@ -35,6 +35,8 @@
 
 struct uart_driver *dr8=0,*dr9=0;
 
+#define BOARD_ID_7300 0x7300
+
 static int tryInitPort(int base) {
   struct tsuart_port *ts1,*ts2;
 
@@ -53,6 +55,9 @@
   ts1->portStatus = &ts1->pstatus;
   ts1->pstatus = 0;
   ts1->u.irq = 40;
+  ts1->mdmctrl = 0;
+  ts1->localStatus |= PORT_STATUS_SHIRQ;
+  ts1->boardId = BOARD_ID_7300;
 
   ts2 = kmalloc(sizeof(struct tsuart_port),GFP_KERNEL);
   if (!ts2) {
@@ -68,8 +73,12 @@
   ts2->debugFlags = portDebug;
   ts2->u.mapbase = 0x72000000 + base;
   ts2->portStatus = &ts1->pstatus;
+  ts2->pstatus |= PORT_STATUS_TXMSB;
   ts2->u.irq = 40;
-  //  printk("registering %p,%p\n",ts1,ts2);
+  ts2->mdmctrl = 0;
+  ts2->localStatus |= PORT_STATUS_SHIRQ;
+  ts2->boardId = BOARD_ID_7300;
+  printk("registering %p,%p\n",ts1,ts2);
   if (tsuart_register_port(dr8,ts1) == 0) {
     //    return 1;
   }
Index: drivers/serial/tsuart-733.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-733.c,v
retrieving revision 1.1
retrieving revision 1.6
diff -u -r1.1 -r1.6
--- drivers/serial/tsuart-733.c	13 Feb 2007 18:09:37 -0000	1.1
+++ drivers/serial/tsuart-733.c	13 Jul 2007 15:34:23 -0000	1.6
@@ -63,22 +63,21 @@
   }
   init_tsuart_port(ts2);
   ts2->u.iotype = SERIAL_IO_MEM;
-  ts2->get = tsuartGetMEM16;
-  ts2->put = tsuartPutMEM16;
+  ts2->get = tsuartGetMEM16_9;
+  ts2->put = tsuartPutMEM16_9;
   ts2->debugFlags = portDebug;
   ts2->u.mapbase = 0x72000400+i;
   ts2->boardId = BOARD_ID_733;
   ts2->u.irq = 40;
   ts2->mdmctrl = 0;
   ts2->localStatus |= PORT_STATUS_SHIRQ;
-
   if (tsuart_register_port(dr8,ts1) == 0) {
-    //return 1;
+    //return 0;
   }
   if (tsuart_register_port(dr9,ts2) == 0) {
-    //return 1;
+    //return 0;
   }
-  return 0;
+  return 1;
 }
 
 #define TTY_NAME8 "ttyT8Sv"
@@ -95,13 +94,14 @@
 
 static int __init tsuart_init(void)
 {
+  int ports = 0;
   if (!tty) {
     tty = TTY_NAME8;
   }
   if (!cua) {
     cua = CUA_NAME8;
   }
-  printk("TS-UART/736 assuming TS-733 board\n");
+  printk("TS-UART/733 assuming TS-733 board\n");
   dr8 = kmalloc(sizeof(struct uart_driver),GFP_KERNEL);
   if (!dr8) {
     printk("Unable to allocate memory for tsuart port\n");
@@ -113,7 +113,7 @@
     printk("Unable to allocate memory for tsuart port\n");
     return 0;
   }
- if (!tsuart_configure_driver(dr8,234,122,tty,cua,3)) {
+  if (!tsuart_configure_driver(dr8,234,122,tty,cua,3)) {
     kfree(dr8);
     kfree(dr9);
     return 0;
@@ -125,15 +125,17 @@
   }
 
   if (tryInitPort(0)) {
-    return 0;
+    ports++;
   }
   if (tryInitPort(4)) {
-    return 0;
+    ports++;
   }
   if (tryInitPort(8)) {
-    return 0;
+    ports++;
   }
-  return -1;
+  printk("TS-UART/733 found %d ports\n",ports);
+  if(ports == 0) return -1; 
+  else return 0;
 }
 
 static void __exit tsuart_exit(void)
Index: drivers/serial/tsuart-734.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-734.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/serial/tsuart-734.c	9 May 2007 16:59:06 -0000	1.1
+++ drivers/serial/tsuart-734.c	10 May 2007 00:08:07 -0000	1.2
@@ -51,6 +51,8 @@
   ts1->put = tsuartPutMEM16;
   ts1->debugFlags = portDebug;
   ts1->u.mapbase = 0x72000400+i*4;
+  ts1->portStatus = &ts1->pstatus;
+  ts1->pstatus = 0;
   ts1->boardId = BOARD_ID_734;
   ts1->u.irq = 40;
   ts1->mdmctrl = 0;
@@ -62,11 +64,15 @@
     return 0;
   }
   init_tsuart_port(ts2);
+  ts2->rxsize = 2;
+  ts2->dataMask = 0x1FF;
   ts2->u.iotype = SERIAL_IO_MEM;
   ts2->get = tsuartGetMEM16_9;
   ts2->put = tsuartPutMEM16_9;
   ts2->debugFlags = portDebug;
   ts2->u.mapbase = 0x72000400+i*4;
+  ts2->portStatus = &ts1->pstatus;
+  ts2->pstatus |= PORT_STATUS_TXMSB;
   ts2->boardId = BOARD_ID_734;
   ts2->u.irq = 40;
   ts2->mdmctrl = 0;
Index: drivers/serial/tsuart-736.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-736.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/serial/tsuart-736.c	7 Dec 2006 23:59:01 -0000	1.1
+++ drivers/serial/tsuart-736.c	8 Dec 2006 21:24:37 -0000	1.3
@@ -45,6 +45,8 @@
   port = (((int)ts->u.mapbase) - 0x72000400)/4;
   if (port < 8) {
     mask = 1 << port;
+  } else if (port < 16) {
+    mask = 1 << (port-8);
   }
    if (mctrl & 0x80000000) { // set
     if ((mctrl & TIOCM_DTR)) {
@@ -57,7 +59,7 @@
       }
     }
   } else { // get
-    if (*ctrlbits & mask) {
+    if (*ctrlbits & (mask<<8)) {
       ctrl |= TIOCM_CD;
     }
   }
@@ -113,7 +115,6 @@
   }
   if (!ctrlbits) {
     ctrlbits = (volatile unsigned short *)((int) __ioremap(0x72000000, 4096,0) + 0x460);
-    printk("DEBUG: %p\n",ctrlbits);
   }
   //ctrlbits = 0;
   return 1;
@@ -156,17 +157,17 @@
     printk("Unable to allocate memory for tsuart port\n");
     return 0;
   }
- if (!tsuart_configure_driver(dr8,234,64,tty,cua,24)) {
+ if (!tsuart_configure_driver(dr8,234,128,tty,cua,24)) {
     kfree(dr8);
     kfree(dr9);
     return 0;    
   }
-  if (!tsuart_configure_driver(dr9,234,72,tty9,cua9,24)) {
+  if (!tsuart_configure_driver(dr9,234,152,tty9,cua9,24)) {
     kfree(dr8);
     kfree(dr9);
     return 0;    
   }
-  for (i=0;i<=24*4;i+=4) {
+  for (i=0;i<24*4;i+=4) {
     if (tryInitPort(i)) {
       ports++;
     }
Index: drivers/serial/tsuart-bat3.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-bat3.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/serial/tsuart-bat3.c	16 May 2006 19:12:38 -0000	1.1
+++ drivers/serial/tsuart-bat3.c	4 Oct 2006 15:14:28 -0000	1.4
@@ -33,6 +33,10 @@
 #include <asm/uaccess.h>
 #include "tsuart.h"
 
+#define BOARD_ID_BAT3 0xBA13
+
+struct uart_driver *dr3=0;
+
 static int tryInitPort(int iobase) {
   struct tsuart_port *ts;
   unsigned val;
@@ -48,21 +52,22 @@
   ts->put = tsuartPutIO8;
   ts->debugFlags = portDebug;
   ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + iobase;
-
+  ts->boardId = BOARD_ID_BAT3;
+  ts->mdmctrl = 0;
   val = tsuartGetIO8(ts,0);
   if (val == 0x28) {
     val = tsuartGetIO8(ts,1);
     if ((val & 0x80) == 0x80) {
       ts->u.irq = 33;
       if ((val & 0x40) == 0x40) {
-	// IRQ6 with sharing...
+	ts->localStatus |= PORT_STATUS_SHIRQ; // IRQ6 with sharing...
       }
     } else {
       ts->u.irq = 32; // IRQ5... is this right?
     }
     ts->u.iobase += 2; // point to STAT register
     printk("TS-UART/BAT3 found at port 0x%04X\n",iobase);
-    if (tsuart_register_port(0,ts) == 0) {
+    if (tsuart_register_port(dr3,ts) == 0) {
       return 1;
     }
   }
@@ -73,6 +78,16 @@
 {
   int ports=0;
 
+  dr3 = kmalloc(sizeof(struct uart_driver),GFP_KERNEL);
+  if (!dr3) {
+    printk("Unable to allocate memory for tsuart port\n");
+    return 0;
+  }
+ if (!tsuart_configure_driver(dr3,234,95,"ttyT3S","cuat3s",4)) {
+    kfree(dr3);
+    return 0;
+  }
+
   if (tryInitPort(0x100)) {
     ports++;
   }
Index: drivers/serial/tsuart-boc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-boc.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/serial/tsuart-boc.c	1 Feb 2007 23:43:41 -0000	1.1
+++ drivers/serial/tsuart-boc.c	6 Feb 2007 16:37:51 -0000	1.5
@@ -51,14 +51,10 @@
   ts->debugFlags = portDebug;
   ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + iobase;
   ts->boardId = BOARD_ID_BOC;
-  val = tsuartGetIO8(ts,0);
-  if (val == 0x8e) {
-    val = tsuartGetIO8(ts,1);
-    ts->u.irq = 33;
-    printk("TS-UART/BOC found at port 0x%04X\n",iobase);
-    if (tsuart_register_port(0,ts) == 0) {
-      return 1;
-    }
+  ts->u.irq = 40;
+  printk("TS-UART/BOC found at port 0x%04X\n",iobase);
+  if (tsuart_register_port(0,ts) == 0) {
+    return 1;
   }
   return 0;
 }
@@ -66,6 +62,13 @@
 static int __init tsuart_init(void)
 {
   int ports=0;
+  struct tsuart_port *ts;
+  
+  //Ensure we clear any IRQs before registering an IRQ
+  ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + 0x134;
+  while (bit_DR(tsuartGetIO8(ts,0))) tsuartGetIO8(ts,1);
+  ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + 0x136;
+  while (bit_DR(tsuartGetIO8(ts,0))) tsuartGetIO8(ts,1);
 
   if (tryInitPort(0x134)) {
     ports++;
Index: drivers/serial/tsuart-corestreet.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-corestreet.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/serial/tsuart-corestreet.c	1 Sep 2007 00:45:35 -0000	1.1
+++ drivers/serial/tsuart-corestreet.c	11 Jan 2008 00:14:38 -0000	1.3
@@ -98,22 +98,6 @@
     printk(KERN_ERR "tsuart-corestreet: cannot map adrs memory\n");
     return -ENOMEM;
   }
-
-  init_tsuart_port(ts);
-  ts->u.iotype = SERIAL_IO_MEM;
-  ts->get = tsuartGetCST8;
-  ts->put = tsuartPutCST8;
-  ts->mdmctrl = 0;
-  ts->debugFlags = portDebug;
-  ts->u.mapbase = 0x60c00000;
-  ts->u.irq = 32; // 33; // UNKNOWN, FIXME 32,33,40
-  ts->localStatus |= PORT_STATUS_SHIRQ;
-  ts->boardId = BOARD_ID_CORESTREET;
-
-  if (tsuart_register_port(0,ts) != 0) {
-    return 0;
-  }
-
   // now do magic knock sequence to enable board
   *(adrs_reg-2) = 0xff;
   *(adrs_reg-1) = 0x17;
@@ -129,6 +113,32 @@
     *tmp = 8;
     //__iounmap(tmp);
   }
+  {
+    volatile unsigned long *tmp;
+
+    tmp = ((unsigned long *) __ioremap(0x80080000, 4096,0))+ 0x07;
+    if (tmp == (unsigned long *)0x80080007) {
+      printk(KERN_ERR "tsuart-corestreet: cannot map 0x8008_0007\n");
+      return -ENOMEM;
+    }
+    *tmp = 0xffef;
+    //__iounmap(tmp);
+  }
+
+  init_tsuart_port(ts);
+  ts->u.iotype = SERIAL_IO_MEM;
+  ts->get = tsuartGetCST8;
+  ts->put = tsuartPutCST8;
+  ts->mdmctrl = 0;
+  ts->debugFlags = portDebug;
+  ts->u.mapbase = 0x70c00000;
+  ts->u.irq = 32; // 33; // UNKNOWN, FIXME 32,33,40
+  ts->localStatus |= PORT_STATUS_SHIRQ;
+  ts->boardId = BOARD_ID_CORESTREET;
+
+  if (tsuart_register_port(0,ts) != 0) {
+    return 0;
+  }
 
   return 1;
 }
Index: drivers/serial/tsuart-dmx.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-dmx.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/serial/tsuart-dmx.c	30 Jun 2007 01:10:26 -0000	1.1
+++ drivers/serial/tsuart-dmx.c	23 Oct 2008 17:59:03 -0000	1.5
@@ -1,7 +1,7 @@
 /*
- *  linux/drivers/serial/tsuart-bat3.c
+ *  linux/drivers/serial/tsuart-dmx.c
  *
- *  TS-UART loader for Technologic Systems MARCTEL TS-7300 bitstream
+ *  TS-UART loader for Technologic Systems DMX TS-7300 bitstream
  *
  *  (c) 2007 Technologic Systems
  *
@@ -44,7 +44,6 @@
   unsigned val0 = *((volatile unsigned short *)port->u.membase + 0);
   unsigned val = *((volatile unsigned short *)port->u.membase + offset);
 
-printk("Get %X, Got %X\n",val0,val);
     if (val0 & (1<<11)) {
       port->localStatus |= PORT_STATUS_DMXBRK;
     }
@@ -59,16 +58,23 @@
   }
 }
 
+static inline int bit_TRE(unsigned short reg_value) {
+  return (reg_value & 0x1000) == 0x1000;
+}
+
 void tsuartPutMEM16_9DMX(struct tsuart_port *port,int offset,unsigned value) {
-  if (offset == 1 && port->pstatus & PORT_STATUS_TXMSB && value & (1 << 3)) {
-printk("Sending DMX break\n");
+  int i=0;
+
+  if (offset == 1 && (port->pstatus & PORT_STATUS_TXMSB) && (value & (1 << 3))) {
+    // wait for TRE to tell us the transmitter is idle
+    while (!bit_TRE(*((volatile unsigned short *)port->u.membase)) && i < 1000000) i++;
+    if (i >= 1000000) printk("Timeout waiting for TRE!\n");
     // send DMX break
     *((volatile unsigned short *)port->u.membase + 0) |= (1<<10);
     udelay(92);
     *((volatile unsigned short *)port->u.membase + 0) &= ~(1<<10);
     udelay(12);
     value &= ~(1 << 3);
-printk("Sent DMX break\n");
   }
   tsuartPutMEM16_9(port,offset,value);
 }
@@ -112,7 +118,7 @@
   }
   init_tsuart_port(ts2);
   ts2->rxsize = 2;
-  ts2->dataMask = 0x1FF;
+  ts2->dataMask = 0x9FF;
   ts2->u.iotype = SERIAL_IO_MEM;
   ts2->get = tsuartGetMEM16_9DMX;
   ts2->put = tsuartPutMEM16_9DMX;
@@ -161,11 +167,11 @@
   cr = (volatile unsigned short *)((int) __ioremap(0x72000000, 4096,0) + 0x422);
   if (*cr != 0x8bb7) {
     printk("TS-UART/DMX did not find DMX board\n");
-    __iounmap(cr);
+    __iounmap((void *)cr);
     return -1;
   } else {
     printk("TS-UART/DMX found DMX board\n");
-    __iounmap(cr);
+    __iounmap((void *)cr);
   }
 
   dr8 = kmalloc(sizeof(struct uart_driver),GFP_KERNEL);
Index: drivers/serial/tsuart-marctel.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-marctel.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/serial/tsuart-marctel.c	11 May 2007 20:24:11 -0000	1.1
+++ drivers/serial/tsuart-marctel.c	14 Sep 2007 23:54:43 -0000	1.4
@@ -37,6 +37,46 @@
 
 #define BOARD_ID_MARCTEL 0x735
 
+unsigned tsuartGetMEM16_BRK(struct tsuart_port *port,int offset) {
+  unsigned value;
+  static int inbreak = 0;
+
+  value = *((volatile unsigned short *)port->u.membase + offset);
+  if (offset == 0) {
+    if (bit_RXBRK(value) && !inbreak) {
+      inbreak = 1;
+      port->u.icount.brk++;
+      uart_handle_break(&port->u);
+      if (port->u.info->tty) {
+	*(port->u.info->tty->flip.flag_buf_ptr) = TTY_BREAK;
+	port->u.info->tty->flip.flag_buf_ptr++;
+	port->u.info->tty->flip.char_buf_ptr++;
+	port->u.info->tty->flip.count++;
+      }
+      //      if (uart_handle_sysrq_char(port, ch, regs)) {
+      //      } else {
+      //}
+      tty_flip_buffer_push(port->u.info->tty);
+    }
+  } else {
+    inbreak = 0;
+  }
+  return value;
+}
+
+unsigned tsuartGetMEM16_9_BRK(struct tsuart_port *port,int offset) {
+  unsigned val = *((volatile unsigned short *)port->u.membase + offset);
+
+  if (offset == 1) {
+    return val & 0x1FF;
+  } else if (offset == 0) {
+    if (bit_RXBRK(val)) {
+      uart_handle_break(&port->u);
+    }    
+  }
+  return val;
+}
+
 static int tryInitPort(int i) {
   struct tsuart_port *ts1,*ts2;
 
@@ -47,7 +87,7 @@
   }
   init_tsuart_port(ts1);
   ts1->u.iotype = SERIAL_IO_MEM;
-  ts1->get = tsuartGetMEM16;
+  ts1->get = tsuartGetMEM16_BRK;
   ts1->put = tsuartPutMEM16;
   ts1->debugFlags = portDebug;
   ts1->u.mapbase = 0x72000400+i*4;
@@ -67,7 +107,7 @@
   ts2->rxsize = 2;
   ts2->dataMask = 0x1FF;
   ts2->u.iotype = SERIAL_IO_MEM;
-  ts2->get = tsuartGetMEM16_9;
+  ts2->get = tsuartGetMEM16_9_BRK;
   ts2->put = tsuartPutMEM16_9;
   ts2->debugFlags = portDebug;
   ts2->u.mapbase = 0x72000400+i*4;
Index: drivers/serial/tsuart-mwarm.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-mwarm.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/serial/tsuart-mwarm.c	26 Mar 2007 20:02:08 -0000	1.1
+++ drivers/serial/tsuart-mwarm.c	7 May 2008 17:51:50 -0000	1.4
@@ -33,29 +33,35 @@
 #include <asm/uaccess.h>
 #include "tsuart.h"
 
-#define TS_MODEL_MWARM 5
+#define TS_MODEL_MWARM 2
 #define BOARD_ID_MWARM 0x7261
+#define DEBUG_INTERFACE 8
 
 static inline int get_status(void) {
 //  return 0;
   return (inb(TS7XXX_IO8_BASE + 0x800000));
 }
 
-static inline void set_status(int status) {
-//  return;
-  outb(status,TS7XXX_IO8_BASE + 0x800000);
+static inline void set_status(int i) {
+  if (i) {
+    outb(8|(inb(TS7XXX_IO8_BASE + 0x2000000)),TS7XXX_IO8_BASE + 0x2000000);
+  } else {
+    outb(~8&(inb(TS7XXX_IO8_BASE + 0x2000000)),TS7XXX_IO8_BASE + 0x2000000);
+  }
 }
 
 static int mdmctrl(struct tsuart_port *ts,int mctrl) {
-  int status = get_status();
+  int status;
   int ret = 0;
 
   if (mctrl & 0x80000000) {
     if (mctrl & TIOCM_DTR) {
-      status |= (1 << 2);  // R/W
-      set_status(status);
+      set_status(0);
+    } else {
+      set_status(1);
     }
   }
+  status = get_status();
   if (status & (1 << 2)) {
     ret |= TIOCM_DTR;
   }
Index: drivers/serial/tsuart-pac4.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-pac4.c,v
retrieving revision 1.1
retrieving revision 1.6
diff -u -r1.1 -r1.6
--- drivers/serial/tsuart-pac4.c	26 May 2006 23:26:03 -0000	1.1
+++ drivers/serial/tsuart-pac4.c	3 Mar 2009 00:45:53 -0000	1.6
@@ -1,5 +1,5 @@
 /*
- *  linux/drivers/serial/tsuart7260.c
+ *  linux/drivers/serial/tsuart-pac4.c
  *
  *  TS-UART loader for Technologic Systems TS-7260
  *
@@ -47,20 +47,41 @@
   its for us.
  */
 unsigned tsuartGetMUX8(struct tsuart_port *port,int offset) {
+  unsigned val = -1;
+  int src;
   /*
     if reading the STAT register, mask out the flow control bit since
     its really telling us whether data is for us or not.  use this bit
     to instead condition data ready, so we know whether or not data is
     for us.
    */
+  if (offset == 1) { // DATA
+    src = bit_CTS(*(volatile unsigned char *)port->u.membase);
+    if (src == port->u.line) {
+      return -1;
+    }
+    
+    val = *((volatile unsigned char *)port->u.membase + offset);
+  } else if (offset == 0) { // STAT
+    val = *((volatile unsigned char *)port->u.membase + offset);
+    
+    if (bit_CTS(val) == port->u.line) {
+      val = val & 0xFD;
+    }
+    
+    val = val | 0x08; // sorry, no constant, CTS wasn't writable
+  }
+  return val;
 }
 
 void tsuartPutMUX8(struct tsuart_port *port,int offset,unsigned value) {
+  *((volatile unsigned char *)port->u.membase + offset) = value;
 }
 
+struct uart_driver *drc=0,*drd=0;
 
 #define BOARD_ID_PAC4 0x7404
-static int tryInitPort(int base) {
+static int tryInitPort(int base,struct uart_driver *dr) {
   struct tsuart_port *ts;
 
   ts = kmalloc(sizeof(struct tsuart_port),GFP_KERNEL);
@@ -71,14 +92,22 @@
 
   init_tsuart_port(ts);
   ts->u.iotype = SERIAL_IO_MEM;
-  ts->get = tsuartGetMUX8;
-  ts->put = tsuartPutMUX8;
+  if (dr != 0) {
+    ts->get = tsuartGetMUX8;
+    ts->put = tsuartPutMUX8;
+  }  else {
+    ts->get = tsuartGetMEM8;
+    ts->put = tsuartPutMEM8;
+  }
   ts->debugFlags = portDebug;
   ts->u.mapbase = /*0 x72000000 + */ base;
   ts->u.irq = 32;
+  ts->mdmctrl = 0;
   ts->boardId = BOARD_ID_PAC4;
-
-  if (tsuart_register_port(0,ts) != 0) {
+  if (dr) {
+    //    ts->localStatus |= PORT_STATUS_SHIRQ;
+  }
+  if (tsuart_register_port(dr,ts) != 0) {
     return 0;
   }
   return 1;
@@ -87,7 +116,6 @@
 static int __init tsuart_init(void)
 {
   int ports=0;
-  int ret;
 	
   if (get_ts_model() != TS_MODEL_PAC4) {
     printk("TS-UART/PAC4 did not detect a TS-PAC4 board\n");
@@ -95,20 +123,48 @@
   } else {
     printk("TS-UART/PAC4 detected a TS-PAC4 board\n");
   }
-  ret = procfile_init();
-  if (ret) {
-    return ret;
+
+  drc = kmalloc(sizeof(struct uart_driver),GFP_KERNEL);
+  if (!drc) {
+    printk("Unable to allocate memory for tsuart port\n");
+    return 0;
+  }
+  drd = kmalloc(sizeof(struct uart_driver),GFP_KERNEL);
+  if (!drd) {
+    kfree(drc);
+    printk("Unable to allocate memory for tsuart port\n");
+    return 0;
+  }
+ if (!tsuart_configure_driver(drc,234,100,"ttyTSP","cuaTSC",2)) {
+    kfree(drc);
+    kfree(drd);
+    return 0;    
+  }
+ /*
+  if (!tsuart_configure_driver(drd,234,101,"ttyTSD","cuaTSD",1)) {
+    kfree(drc);
+    kfree(drd);
+    return 0;    
+  }
+ */
+  if (tryInitPort(0x12400000,0)) {
+    ports++;
   }
 
-  if (tryInitPort(0x12400000)) {
+  if (tryInitPort(0x12400002,drc)) {
     ports++;
   }
+
+  if (tryInitPort(0x12400002,drc)) {
+    ports++;
+  }
+
   return (ports > 0) ? 0 : -1;
 }
 
 static void __exit tsuart_exit(void)
 {
-  procfile_exit();  
+  // not safe to unload!
 }
 
 module_init(tsuart_init);
Index: drivers/serial/tsuart-rf.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart-rf.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/serial/tsuart-rf.c	1 Sep 2006 22:57:32 -0000	1.1
+++ drivers/serial/tsuart-rf.c	29 Dec 2006 00:18:07 -0000	1.3
@@ -35,6 +35,20 @@
 
 #define BOARD_ID_TSRF 0x5162
 
+static int mdmctrl(struct tsuart_port *ts,int mctrl) {
+  int dtr;
+
+  if (mctrl & 0x80000000) {
+    tsuartPutIO8(ts,-1,
+		 (tsuartGetIO8(ts,-1) & 0xFE) | 
+		 ((mctrl & TIOCM_DTR) ? 1 : 0));
+    dtr =  mctrl & TIOCM_DTR;
+  } else {
+    dtr = (tsuartGetIO8(ts,-1) & 0x01) ? TIOCM_DTR : 0;
+  }
+  return (TIOCM_CAR | TIOCM_DSR | dtr);
+}
+
 static int tryInitPort(int iobase) {
   struct tsuart_port *ts;
   unsigned val;
@@ -51,15 +65,14 @@
   ts->debugFlags = portDebug;
   ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + iobase;
   ts->boardId = BOARD_ID_TSRF;
+  ts->mdmctrl = mdmctrl;
   val = tsuartGetIO8(ts,0);
   if (val == 0x8e) {
     val = tsuartGetIO8(ts,1);
+    ts->localStatus |= PORT_STATUS_SHIRQ; //share IRQ6 & IRQ7 with IDE
     if ((val & 0x80) == 0x80) {
       // assuming IRQ6=33, IRQ7=40
       ts->u.irq = 40;
-      if ((val & 0x40) == 0x40) {
-	ts->localStatus |= PORT_STATUS_SHIRQ; // IRQ7 with sharing...
-      }
     } else {
       ts->u.irq = 33;
     }
